{% extends "base.html" %}

{% block content %}

    <script>
        // Hide the local networks input fields when the L3-status checkbox is unchecked
        $(document).ready(function () {
            let toggle_checkbox = $("#l3");
            if (!toggle_checkbox.prop("checked")) {
                let to_hide = $(".local-networks-hide");
                let to_disable = $(".local-networks");
                to_hide.hide();
                to_disable.hide();
                to_disable.prop('disabled', true);
            }

            toggle_checkbox.change(function () {
                let to_hide = $(".local-networks-hide");
                let to_disable = $(".local-networks");
                if ($(this).prop("checked")) {
                    to_hide.show();
                    to_disable.show();
                    to_disable.prop('disabled', false);
                } else {
                    to_hide.hide();
                    to_disable.hide();
                    to_disable.prop('disabled', true);
                }
            });
        });
    </script>
    <div class="row">
        <div class="col-6">
            <form class="text-center border border-light p-5" action="{{ url_for("url.setup_s2s") }}" method="post">
                {{ form.hidden_tag() }}
                <p class="h4 mb-4">{{ title }}</p>

                <!-- PARAMETER: Activate L3 or L2 Configuration -->
                <hr>
                {% if not s2s_config %}
                    <div class="text-left mt-4">
                        <input type="checkbox" id="l3" name="l3" checked
                               data-toggle="toggle" data-height="50" data-width="100" data-on="Layer 3"
                               data-off="Layer 2">
                        <label for="l3">VPN-Type</label>
                    </div>
                {% elif s2s_config.l3 %}
                    <div class="text-left mt-4">
                        <input type="checkbox" id="l3" name="l3" checked
                               data-toggle="toggle" data-height="50" data-width="100" data-on="Layer 3"
                               data-off="Layer 2">
                        <label for="l3">VPN-Type</label>
                    </div>
                {% else %}
                    <div class="text-left mt-4">
                        <input type="checkbox" id="l3" name="l3"
                               data-toggle="toggle" data-height="50" data-width="100" data-on="Layer 3"
                               data-off="Layer 2">
                        <label for="l3">VPN-Type</label>
                    </div>
                {% endif %}
                <br>
                <hr>

                <p class="h5 mb-5">Site A</p>


                <!-- PARAMETER: Informing about changing current configuration -->
                {% if s2s_config %}
                    <div class="alert alert-danger fade show" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span
                                aria-hidden="true">&times;</span></button>
                        <strong>Pay attention you are about to update your current Remote Access parameters!</strong>
                    </div>
                {% endif %}

                <!-- A Public IP -->
                <div class="form-group text-left">
                    <label for="{{ form.a_public_ip.id }}">Public IP</label>
                    {% if form.a_public_ip.errors %}
                        {{ form.a_public_ip(size=15, class="form-control is-invalid", placeholder="Public IP") }}
                        <div class="invalid-feedback">{{ form.a_public_ip.errors[0] }}</div>
                    {% else %}
                        {{ form.a_public_ip(size=15, class="form-control", placeholder="Public IP", value=s2s_config.a_public_ip or '') }}
                    {% endif %}
                </div>

                <!-- A Public Port -->
                <div class="form-group text-left">
                    <label for="{{ form.a_public_port.id }}">Public Port</label>
                    {% if form.a_public_port.errors %}
                        {{ form.a_public_port(class="form-control is-invalid", placeholder="Public Port") }}
                        <div class="invalid-feedback">{{ form.a_public_port.errors[0] }}</div>
                    {% else %}
                        {{ form.a_public_port(class="form-control", placeholder="Public Port", value=s2s_config.a_public_port or '') }}
                    {% endif %}
                </div>

                <!-- A Tunnel IP + Mask (CIDR) -->
                <div class="form-group text-left">
                    <label for="{{ form.a_tunnel_cidr.id }}">Tunnel IP / Prefix</label>
                    {% if form.a_tunnel_cidr.errors %}
                        {{ form.a_tunnel_cidr(class="form-control is-invalid", placeholder="Tunnel IP: 172.16.253.1/24") }}
                        <div class="invalid-feedback">{{ form.a_tunnel_cidr.errors[0] }}</div>
                    {% else %}
                        {{ form.a_tunnel_cidr(class="form-control", placeholder="Tunnel IP: 172.16.253.1/24", value=s2s_config.a_tunnel_cidr or '') }}
                    {% endif %}
                </div>

                <!-- A Local Networks -->
                <div class="form-group text-left">
                    <label for="{{ form.a_local_networks.id }}" class="local-networks-hide">Local networks / Prefix</label>
                    {% if form.a_local_networks.errors %}
                        {{ form.a_local_networks(class="form-control is-invalid local-networks", placeholder="Local networks: 192.168.1.0/24, 10.10.10.0/23") }}
                        <div class="invalid-feedback">{{ form.a_local_networks.errors[0] }}</div>
                    {% else %}
                        {{ form.a_local_networks(class="form-control local-networks", placeholder="Local networks: 192.168.1.0/24, 10.10.10.0/23", value=s2s_config.a_local_networks or '') }}
                    {% endif %}
                </div>

                <hr>
                <p class="h5 mb-5">Site B</p>

                <!-- B Public IP -->
                <div class="form-group text-left">
                    <label for="{{ form.b_public_ip.id }}">Public IP</label>
                    {% if form.b_public_ip.errors %}
                        {{ form.b_public_ip(size=15, class="form-control is-invalid", placeholder="Public IP") }}
                        <div class="invalid-feedback">{{ form.b_public_ip.errors[0] }}</div>
                    {% else %}
                        {{ form.b_public_ip(size=15, class="form-control", placeholder="Public IP", value=s2s_config.b_public_ip or '') }}
                    {% endif %}
                </div>

                <!-- B Public Port -->
                <div class="form-group text-left">
                    <label for="{{ form.b_public_port.id }}">Public Port</label>
                    {% if form.b_public_port.errors %}
                        {{ form.b_public_port(class="form-control is-invalid", placeholder="Public Port") }}
                        <div class="invalid-feedback">{{ form.b_public_port.errors[0] }}</div>
                    {% else %}
                        {{ form.b_public_port(class="form-control", placeholder="Public Port", value=s2s_config.b_public_port or '') }}
                    {% endif %}
                </div>

                <!-- B Tunnel IP + Mask (CIDR) -->
                <div class="form-group text-left">
                    <label for="{{ form.b_tunnel_cidr.id }}">Tunnel IP / Prefix</label>
                    {% if form.b_tunnel_cidr.errors %}
                        {{ form.b_tunnel_cidr(class="form-control is-invalid", placeholder="Tunnel IP: 172.16.253.2/24") }}
                        <div class="invalid-feedback">{{ form.b_tunnel_cidr.errors[0] }}</div>
                    {% else %}
                        {{ form.b_tunnel_cidr(class="form-control", placeholder="Tunnel IP: 172.16.253.2/24", value=s2s_config.b_tunnel_cidr or '') }}
                    {% endif %}
                </div>

                <!-- B Local Networks -->
                <div class="form-group text-left">
                    <label for="{{ form.b_local_networks.id }}" class="local-networks-hide">Local networks / Prefix</label>
                    {% if form.b_local_networks.errors %}
                        {{ form.b_local_networks(class="form-control is-invalid local-networks", placeholder="Local networks: 192.168.2.0/24, 10.10.12.0/23") }}
                        <div class="invalid-feedback">{{ form.b_local_networks.errors[0] }}</div>
                    {% else %}
                        {{ form.b_local_networks(class="form-control local-networks", placeholder="Local networks: 192.168.2.0/24, 10.10.12.0/23", value=s2s_config.b_local_networks or '') }}
                    {% endif %}
                </div>

                <hr>
                <p class="h5 mb-5">Options</p>
                <!-- Use PSK checkbox -->
                {% if s2s_config.psk %}
                    <div class="form-check text-left">
                        {{ form.psk(class="form-check-input", checked="") }}
                        <label class="form-check-label" for="{{ form.psk.id }}">Generate and use a pre-shared
                            key?</label>
                    </div>
                {% else %}
                    <div class="form-check text-left">
                        {{ form.psk(class="form-check-input") }}
                        <label class="form-check-label" for="{{ form.psk.id }}">Generate and use a pre-shared
                            key?</label>
                    </div>
                {% endif %}


                <!-- Keepalive -->
                {% if form.keepalive.errors %}
                    <div class="form-group text-left mt-4">
                        <label for="{{ form.keepalive.id }}">Keepalive in seconds</label>
                        {{ form.keepalive(class="form-control is-invalid", placeholder="0 - 65535") }}
                        <div class="invalid-feedback">
                            {{ form.keepalive.errors[0] }}
                        </div>
                    </div>
                {% else %}
                    <div class="form-group text-left mt-4">
                        <label for="{{ form.keepalive.id }}">Keepalive in seconds</label>
                        {% if s2s_config.keepalive %}
                            {{ form.keepalive(class="form-control", placeholder="0 - 65535", value=s2s_config.keepalive) }}
                        {% elif s2s_config.keepalive == 0 %}
                            {{ form.keepalive(class="form-control", placeholder="0 - 65535", value='0') }}
                        {% else %}
                            {{ form.keepalive(class="form-control", placeholder="0 - 65535", value='') }}
                        {% endif %}
                    </div>
                {% endif %}

                <!-- Send button -->
                {% if s2s_config %}
                    {{ form.submit(class="btn btn-danger btn-block mt-4", value="Overwrite S2S config!") }}
                {% else %}
                    {{ form.submit(class="btn btn-primary btn-block mt-4") }}
                {% endif %}

            </form>
        </div>


        <div class="col-6">

            <form class="text-center border border-light p-5" action="{{ url_for("url.import_s2s") }}" method="post"
                  enctype="multipart/form-data">
                {{ upload_form.hidden_tag() }}
                <p class="h4 mb-4">Import</p>
                <p class="h5 mb-5">Import a settings file here</p>

                <!-- IMPORT: Informing about changing current configuration -->
                {% if s2s_config %}
                    <div class="alert alert-danger fade show" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span
                                aria-hidden="true">&times;</span></button>
                        <strong>Pay attention you are about to overwrite your current Remote Access
                            configuration!</strong>
                    </div>
                {% endif %}

                {% if upload_form.config_file.error %}
                    {{ upload_form.config_file(class="mb-4") }}
                {% else %}
                    {{ upload_form.config_file(class="mb-4") }}
                {% endif %}

                {% if s2s_config %}
                    {{ upload_form.submit(class="btn btn-danger btn-block", value="Overwrite S2S config!") }}
                {% else %}
                    {{ upload_form.submit(class="btn btn-primary btn-block") }}
                {% endif %}
        </div>
    </div>

{% endblock %}